package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.JoinUs;
import com.izouma.awesomeadmin.service.JoinUsService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/joinUs")
@RequiresAuthentication
public class JoinUsController {

    @Autowired
    private JoinUsService joinUsService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(JoinUs record) {
        List<JoinUs> pp = joinUsService.getJoinUsList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getJoinUs", method = RequestMethod.GET)
    @ResponseBody
    public Result getJoinUs(@RequestParam(required = false, value = "id") String id) {
        JoinUs data = joinUsService.getJoinUsById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(JoinUs record) {
        JoinUs data = joinUsService.getJoinUs(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, JoinUs record) {
        Map<String, Object> result = new HashMap<>();

        List<JoinUs> pp =joinUsService.getJoinUsByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(JoinUs record) {
        boolean num = joinUsService.createJoinUs(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateJoinUs(JoinUs record) {
        boolean num = joinUsService.updateJoinUs(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteJoinUs(@RequestParam(required = true, value = "id") String id) {

        boolean num = joinUsService.deleteJoinUs(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, JoinUs record) throws Exception {

    List<JoinUs> joinUss = joinUsService.getJoinUsList(record);


        String sheetName = "join_us";
        String titleName = "加入我们数据表";
        String fileName = "加入我们表";
        int columnNumber = 10;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "招聘宣言" ,   "邮箱" ,   "联系方式" ,   "招聘网站"  };
        String[][] dataList = new String[joinUss.size()][10];

        for (int i = 0; i < joinUss.size(); i++) {

                        dataList[i][0] = String.valueOf(joinUss.get(i).getId());
                        dataList[i][1] = String.valueOf(joinUss.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(joinUss.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(joinUss.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(joinUss.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(joinUss.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(joinUss.get(i).getManifesto());
                        dataList[i][7] = String.valueOf(joinUss.get(i).getEmail());
                        dataList[i][8] = String.valueOf(joinUss.get(i).getTelephone());
                        dataList[i][9] = String.valueOf(joinUss.get(i).getZhaopin());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

